package
{
	import maxmotion3d.*;
	import models.*;
	import flash.events.*;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.ui.Keyboard;
	import flash.geom.Vector3D;

	public class Main extends Sprite 
	{
		private var _scene:Scene3D;
		private var _model:Model3D;
		private var _model2:Model3D;
		private var _bg:Model3D;
		private var _keyUp:Boolean = false;
		private var _keyDown:Boolean = false;
		private var _keyLeft:Boolean = false;
		private var _keyRight:Boolean = false;
		private var _location:MaxText = new MaxText(14,0xffffff);

		public function Main()
		{
			stage.stage3Ds[0].addEventListener(Event.CONTEXT3D_CREATE, init);
			_scene = new Scene3D(this);
		}

		public function init(event:Event):void
		{
			_scene.initScene3D();

			_model = new Jersey(_scene);
			_model2 = new SharpHair(_scene);
			_bg = new Ground(_scene);
			_model._pos = new Vector3D(1200, 0, 1200);

			addChild(_location);

			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}

		protected function enterFrameHandler(event:Event):void
		{
			var pos:Vector3D = _model.getPos();

			_scene._context3D.clear(0.6, 0.8, 1, 1);

			if ( _keyLeft )
			{
				_model.addRotateY(4);
			}
			if ( _keyRight )
			{
				_model.addRotateY(-4);
			}
			if ( _keyUp )
			{
				pos = _model.forward(10);
			}
			if ( _keyDown )
			{
				pos = _model.forward(-10);
			}
			if ( _bg.intersect(pos, new Vector3D(0, -1, 0)) )
			{
				_model._pos.x = pos.x;
				_model._pos.y = pos.y - _bg._distance + 20;
				_model._pos.z = pos.z;
			}

			_model2._rotate.y = _model2.dirDegree(_model._pos);

			_scene._eye = _model.posPlus(800, 600, 800);
			_scene._lookAt = _model.posPlus(0, 200, 0);
			_scene.setCamera();

			_model.draw(_scene);
			_model2.draw(_scene);
			_bg.draw(_scene);

			_scene._context3D.present();

			var p:Point = _scene.getScreenPos(_model2._pos);
			_location.x = p.x;
			_location.y = p.y;
			_location.text = "X="+p.x+",Y="+p.y; 
		}

		private function keyDownHandler(event:KeyboardEvent):void
		{
			switch ( event.keyCode )
			{
				case Keyboard.UP:
					_keyUp = true;
					break;
				case Keyboard.DOWN:
					_keyDown = true;
					break;
				case Keyboard.LEFT:
					_keyLeft = true;
					break;
				case Keyboard.RIGHT:
					_keyRight = true;
					break;
			}
		}

		private function keyUpHandler(event:KeyboardEvent):void
		{
			switch ( event.keyCode )
			{
				case Keyboard.UP:
					_keyUp = false;
					break;
				case Keyboard.DOWN:
					_keyDown = false;
					break;
				case Keyboard.LEFT:
					_keyLeft = false;
					break;
				case Keyboard.RIGHT:
					_keyRight = false;
					break;
			}
		}
	}
}
