package maxmotion3d 
{
	import flash.display3D.*;
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;

	public class BoneModel3D extends Model3D
	{
		public function BoneModel3D(materialsNum:uint = 1) 
		{
			super(materialsNum);
		}

		protected function addMatrix3():void
		{
			_animations.push(new Vector.<Vector.<Matrix3D>>());
			_currentAnimation = _animations.length - 1;
		}

		protected function addMatrix2():void
		{
			_animations[_currentAnimation].push(new Vector.<Matrix3D>());
			_current = _animations[_currentAnimation].length - 1;
		}

		protected function addMatrix(m0:Number,m1:Number,m2:Number,m3:Number,m4:Number,m5:Number,m6:Number,m7:Number,m8:Number,m9:Number,m10:Number,m11:Number,m12:Number,m13:Number,m14:Number,m15:Number):void
		{
			_animations[_currentAnimation][_current].push(new Matrix3D(Vector.<Number>([m0,m1,m2,m3,m4,m5,m6,m7,m8,m9,m10,m11,m12,m13,m14,m15])));
		}
		
		public override function draw(scene:Scene3D):void
		{
			if ( !_visible )
			{
				return;
			}
			var i:int;
			
			for ( i = 0; i < _animations[_currentAnimation][_time].length; i++ )
			{
				scene._context3D.setProgramConstantsFromMatrix(
					Context3DProgramType.VERTEX,
					(i + 1) * 4,
					_animations[_currentAnimation][_time][i],
					true);
			}
			for ( i = 0; i < _textures.length; i++ )
			{
				if ( _vertices[i].length == 0 )
				{
					continue;
				}
				setVertices(scene._context3D,scene._cameraProj,scene._program,i);
				scene._context3D.drawTriangles(_indexBuffer[i]);
			}
			
			if ( _animationPlaying )
			{
				_time++;
				if ( _time >= _animations[_currentAnimation].length )
				{
					if ( _animationLast )
					{
						_time = _animations[_currentAnimation].length - 1;
						_animationPlaying = false;
					}
					else if ( _loopAnimation )
					{
						_time = 0;
					}
					else
					{
						_time = 0;
						_animationPlaying = false;
					}
				}
			}
		}
		
		public override function playAnimation(animation:int, loop:Boolean=true, last:Boolean=false):void
		{
			if ( animation >= 0 )
			{
				_currentAnimation = animation % _animations.length;
			}
			_loopAnimation = loop;
			_animationLast = last;
			_time = 0;
			_animationPlaying = true;
		}
	}
}